Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkHomogeneousTransform Class Reference

`#include <vtkHomogeneousTransform.h>`

Inheritance diagram for vtkHomogeneousTransform:

[legend]
Collaboration diagram for vtkHomogeneousTransform:

[legend]
List of all members.

## Detailed Description

superclass for homogeneous transformations

Date:
  2002/12/26 18:24:21

Revision:
  1.15

vtkHomogeneousTransform provides a generic interface for homogeneous transformations, i.e. transformations which can be represented by multiplying a 4x4 matrix with a homogeneous coordinate.

See also:
  vtkPerspectiveTransform vtkLinearTransform vtkIdentityTransform

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (79%)
  - Geveci, Berk (10%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkHomogeneousTransform.h)`
  - .`cxx` (`/Common/vtkHomogeneousTransform.cxx)`

Definition at line 47 of file vtkHomogeneousTransform.h.

## Public Types
typedef vtkAbstractTransform | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | TransformPoints (vtkPoints *inPts, vtkPoints *outPts)
void | GetMatrix (vtkMatrix4x4 *m)
vtkMatrix4x4 * | GetMatrix ()
virtual void | TransformPointsNormalsVectors (vtkPoints *inPts, vtkPoints *outPts, vtkDataArray *inNms, vtkDataArray *outNms, vtkDataArray *inVrs, vtkDataArray *outVrs)
vtkHomogeneousTransform * | GetHomogeneousInverse ()
void | InternalTransformPoint (const float in[3], float out[3])
void | InternalTransformPoint (const double in[3], double out[3])
void | InternalTransformDerivative (const float in[3], float out[3], float derivative[3][3])
void | InternalTransformDerivative (const double in[3], double out[3], double derivative[3][3])
## Static Public Methods
int | IsTypeOf (const char *type)
vtkHomogeneousTransform * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkHomogeneousTransform ()
| ~vtkHomogeneousTransform ()
void | InternalDeepCopy (vtkAbstractTransform *transform)
## Protected Attributes
vtkMatrix4x4 * | Matrix

## Member Typedef Documentation

typedef vtkAbstractTransform vtkHomogeneousTransform::Superclass

| Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, vtkLinearTransform, vtkMatrixToHomogeneousTransform, vtkMatrixToLinearTransform, vtkPerspectiveTransform, vtkTransform, vtkIterativeClosestPointTransform, and vtkLandmarkTransform. Definition at line 51 of file vtkHomogeneousTransform.h.

## Constructor & Destructor Documentation

vtkHomogeneousTransform::vtkHomogeneousTransform | ( |  | ) | `[protected]`

vtkHomogeneousTransform::~vtkHomogeneousTransform | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkHomogeneousTransform::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, vtkLinearTransform, vtkMatrixToHomogeneousTransform, vtkMatrixToLinearTransform, vtkPerspectiveTransform, vtkTransform, vtkIterativeClosestPointTransform, and vtkLandmarkTransform.

int vtkHomogeneousTransform::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, vtkLinearTransform, vtkMatrixToHomogeneousTransform, vtkMatrixToLinearTransform, vtkPerspectiveTransform, vtkTransform, vtkIterativeClosestPointTransform, and vtkLandmarkTransform.

virtual int vtkHomogeneousTransform::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, vtkLinearTransform, vtkMatrixToHomogeneousTransform, vtkMatrixToLinearTransform, vtkPerspectiveTransform, vtkTransform, vtkIterativeClosestPointTransform, and vtkLandmarkTransform.

vtkHomogeneousTransform* vtkHomogeneousTransform::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, vtkLinearTransform, vtkMatrixToHomogeneousTransform, vtkMatrixToLinearTransform, vtkPerspectiveTransform, vtkTransform, vtkIterativeClosestPointTransform, and vtkLandmarkTransform.

void vtkHomogeneousTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, vtkLinearTransform, vtkMatrixToHomogeneousTransform, vtkMatrixToLinearTransform, vtkPerspectiveTransform, vtkTransform, vtkIterativeClosestPointTransform, and vtkLandmarkTransform.

void vtkHomogeneousTransform::TransformPoints | ( | vtkPoints * | inPts,
|  | vtkPoints * | outPts
| ) | `[virtual]`

| Apply the transformation to a series of points, and append the results to outPts. Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, and vtkLinearTransform.

virtual void vtkHomogeneousTransform::TransformPointsNormalsVectors | ( | vtkPoints * | inPts,
|  | vtkPoints * | outPts,
|  | vtkDataArray * | inNms,
|  | vtkDataArray * | outNms,
|  | vtkDataArray * | inVrs,
|  | vtkDataArray * | outVrs
| ) | `[virtual]`

| Apply the transformation to a combination of points, normals and vectors. Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, and vtkLinearTransform.

void vtkHomogeneousTransform::GetMatrix | ( | vtkMatrix4x4 * | m | ) |

| Get a copy of the internal transformation matrix. The transform is Updated first, to guarantee that the matrix is valid.

vtkMatrix4x4* vtkHomogeneousTransform::GetMatrix | ( |  | ) | `[inline]`

| Get a pointer to an internal vtkMatrix4x4 that represents the transformation. An Update() is called on the transform to ensure that the matrix is up-to-date when you get it. You should not store the matrix pointer anywhere because it might become stale. Definition at line 77 of file vtkHomogeneousTransform.h. References vtkAbstractTransform::Update(). Referenced by vtkTransform::MultiplyPoint().

vtkHomogeneousTransform* vtkHomogeneousTransform::GetHomogeneousInverse | ( |  | ) | `[inline]`

| Just like GetInverse(), but includes typecast to vtkHomogeneousTransform. Definition at line 82 of file vtkHomogeneousTransform.h. References vtkAbstractTransform::GetInverse().

void vtkHomogeneousTransform::InternalTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) | `[virtual]`

| This will calculate the transformation without calling Update. Meant for use only within other VTK classes. Implements vtkAbstractTransform. Reimplemented in vtkIdentityTransform, and vtkLinearTransform.

void vtkHomogeneousTransform::InternalTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) | `[virtual]`

| This will calculate the transformation without calling Update. Meant for use only within other VTK classes. Implements vtkAbstractTransform. Reimplemented in vtkIdentityTransform, and vtkLinearTransform.

void vtkHomogeneousTransform::InternalTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) | `[virtual]`

| This will calculate the transformation as well as its derivative without calling Update. Meant for use only within other VTK classes. Implements vtkAbstractTransform. Reimplemented in vtkIdentityTransform, and vtkLinearTransform.

void vtkHomogeneousTransform::InternalTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) | `[virtual]`

| This will calculate the transformation as well as its derivative without calling Update. Meant for use only within other VTK classes. Implements vtkAbstractTransform. Reimplemented in vtkIdentityTransform, and vtkLinearTransform.

void vtkHomogeneousTransform::InternalDeepCopy | ( | vtkAbstractTransform * | transform | ) | `[protected, virtual]`

| Perform any subclass-specific DeepCopy. Reimplemented from vtkAbstractTransform. Reimplemented in vtkIdentityTransform, vtkMatrixToHomogeneousTransform, vtkMatrixToLinearTransform, vtkPerspectiveTransform, vtkTransform, vtkIterativeClosestPointTransform, and vtkLandmarkTransform.

## Member Data Documentation

vtkMatrix4x4* vtkHomogeneousTransform::Matrix`[protected]`

| Definition at line 108 of file vtkHomogeneousTransform.h.

The documentation for this class was generated from the following file:

- Common/vtkHomogeneousTransform.h